
Imports System.Runtime.InteropServices.Marshal


Public Class USBPIO24
'
'   USBPIO24 NX
'
'   Microchip  mpusbapi.dll  USBPIO-24 pɃJvZ
'@


Public Declare Function _MPUSBGetDeviceCount Lib "mpusbapi.dll" _
    (ByRef pVID_PID As String) As Integer

Public Declare Function MPUSBOpen Lib "mpusbapi.dll" Alias "_MPUSBOpen" _
    (ByVal iInstance As Integer, ByVal pVID_PID As String, ByVal pEP As String, _
     ByVal iDir As Integer, ByVal iReserved As Integer) As Integer

Public Declare Function MPUSBRead Lib "mpusbapi.dll" Alias "_MPUSBRead" _
    (ByVal Handle As Integer, ByVal pData As Integer, ByVal iLen As Integer, _
     ByRef pLen As Integer, ByVal iTimeout As Integer) As Integer

Public Declare Function MPUSBWrite Lib "mpusbapi.dll" Alias "_MPUSBWrite" _
    (ByVal Handle As Integer, ByVal pData As Integer, ByVal iLen As Integer, _
     ByRef pLen As Integer, ByVal iTimeout As Integer) As Integer

Public Declare Function MPUSBClose Lib "mpusbapi.dll" Alias "_MPUSBClose" _
    (ByVal Handle As Integer) As Boolean

Public Declare Auto Function LoadLibrary Lib "kernel32.dll" Alias "LoadLibraryA" _
    (ByVal lpLibFileName As String) As Long

Public Declare Function GetLastError Lib "kernel32" () As Integer


' 萔
Public Const INVALID_HANDLE_VALUE As Short = -1
Public Const ERROR_INVALID_HANDLE As Short = 6

Public Const sVidPid As String = "vid_04d8&pid_ff33"
Public Const sOutPipeName As String = "\MCHP_EP1"
Public Const sInPipeName As String = "\MCHP_EP1"
Public Const MPUSB_FAIL As Short = 0
Public Const MPUSB_SUCCESS As Short = 1
Public Const MP_WRITE As Short = 0
Public Const MP_READ As Short = 1

' o[ϐ
Private hDll As Long
Private hOutPipe(8) As Integer
Private hInPipe(8) As Integer
Private bOpen(8) As Boolean
Private iWriteTimeOut As Integer
Private iReadTimeOut As Integer



Public Sub New()
'
'   RXgN^
'
    Dim i%

    For i = 0 To 7
        hOutPipe(i) = INVALID_HANDLE_VALUE
        hInPipe(i) = INVALID_HANDLE_VALUE
        bOpen(i) = False
    Next i
 '   hDll = LoadLibrary("mpusbapi")
    iWriteTimeOut = 100
    iReadTimeOut = 100

End Sub


Protected Overrides Sub Finalize()
'
'  fXgN^
'
    Dim i%


    For i = 0 To 7
        If (bOpen(i) = True) Then
            Close(i)
        End If
    Next i

    MyBase.Finalize()
End Sub


Public Function Open(ByVal iDevice As Integer) As Boolean
'
'   USBPIO24 foCX̃I[v
'
    bOpen(iDevice) = False
 '   If (hDll = 0) Then
 ''       Open = False
 '       Exit Function
 '   End If

    hOutPipe(iDevice) = MPUSBOpen(iDevice, sVidPid, sOutPipeName, MP_WRITE, 0)
    If (hOutPipe(iDevice) = INVALID_HANDLE_VALUE) Then
        Open = False
        Exit Function
    End If
    hInPipe(iDevice) = MPUSBOpen(iDevice, sVidPid, sInPipeName, MP_READ, 0)
    If (hInPipe(iDevice) = INVALID_HANDLE_VALUE) Then
        Open = False
        Exit Function
    End If
    bOpen(iDevice) = True
    Open = True

End Function

Public Function IsOpen(ByVal iDevice As Integer) As Boolean
'
'   foCX̃I[vԂԂ
'
    If (bOpen(iDevice) = True) Then
        IsOpen = True
    Else
        IsOpen = False
    End If

End Function

Public Sub Close(ByVal iDevice As Integer)
'
'   foCX̃N[Y
'
    If (hOutPipe(iDevice) <> INVALID_HANDLE_VALUE) Then
        MPUSBClose(hOutPipe(iDevice))
    End If
    If (hInPipe(iDevice) <> INVALID_HANDLE_VALUE) Then
        MPUSBClose(hInPipe(iDevice))
    End If
    hOutPipe(iDevice) = hInPipe(iDevice) = INVALID_HANDLE_VALUE
    bOpen(iDevice) = False


End Sub


Public Function Write(ByVal iDevice As Integer, ByVal sCommand As String) As Boolean
'
'   R}h̏o
'
    Dim SendLength As Integer, SentDataLength As Integer
    Dim SendData(255) As Byte

    SendLength = sCommand.Length
    ' R}hoCgzɃRs[
    SendData = System.Text.Encoding.UTF8.GetBytes(sCommand)

    If (MPUSBWrite(hOutPipe(iDevice), UnsafeAddrOfPinnedArrayElement(SendData, 0).ToInt32(), _
            SendLength, SentDataLength, iWriteTimeOut) = MPUSB_SUCCESS) Then



       Write = True
    Else
        Write = False
    End If

End Function


Public Function ReadLine(ByVal iDevice As Integer, ByVal iTimeout As Integer) As String
'
'   ̓ǂݍ݁if~^ = vbCr )
'
     Dim ReceiveData(255) As Byte
    Dim ReceiveLength As Integer, Len As Integer

    If (MPUSBRead(hInPipe(iDevice), UnsafeAddrOfPinnedArrayElement(ReceiveData, 0).ToInt32(), _
        255, ReceiveLength, iReadTimeOut) = MPUSB_SUCCESS) Then

        Len = ReceiveData.Length
        If (ReceiveData(Len - 1) <> 13) Then
            ReadLine = System.Text.Encoding.UTF8.GetString(ReceiveData)
            Exit Function
        End If
        ReceiveData(Len - 1) = 0
        ReadLine = System.Text.Encoding.UTF8.GetString(ReceiveData)
    Else
        ReadLine = Nothing

    End If

End Function




End Class
